std::unordered_multimap::emplace(3)

NAME
std::unordered_multimap::emplace - std::unordered_multimap::emplace

Synopsis
   template< class... Args > (since C++11)
   iterator emplace( Args&&... args );
   Inserts a new element into the container constructed in-place with the given args .
   Careful use of emplace allows the new element to be constructed while avoiding
   unnecessary copy or move operations. The constructor of the new element (i.e.
   std::pair<const Key, T>) is called with exactly the same arguments as supplied to
   emplace, forwarded via std::forward<Args>(args)....
   If rehashing occurs due to the insertion, all iterators are invalidated. Otherwise
   iterators are not affected. References are not invalidated. Rehashing occurs only if
   the new number of elements is greater than max_load_factor()*bucket_count().

Parameters
   args - arguments to forward to the constructor of the element

Return value
   Returns an iterator to the inserted element.

Exceptions
   If an exception is thrown by any operation, this function has no effect (strong
   exception guarantee).

Complexity
   Amortized constant on average, worst case linear in the size of the container.

Example
// Run this code
 #include <iostream>
 #include <utility>
 #include <string>
 #include <unordered_map>
 int main()
 {
     std::unordered_multimap<std::string, std::string> m;
     // uses pair's move constructor
     m.emplace(std::make_pair(std::string("a"), std::string("a")));
     // uses pair's converting move constructor
     m.emplace(std::make_pair("b", "abcd"));
     // uses pair's template constructor
     m.emplace("d", "ddd");
     // uses pair's piecewise constructor
     m.emplace(std::piecewise_construct,
               std::forward_as_tuple("c"),
               std::forward_as_tuple(10, 'c'));
     for (const auto &p : m) {
         std::cout << p.first << " => " << p.second << '\n';
     }
 }

Possible output:
 a => a
 b => abcd
 c => cccccccccc
 d => ddd

See also
   emplace_hint constructs elements in-place using a hint
   (C++11) (public member function)
                inserts elements
   insert or nodes
   (C++11) (since C++17)
                (public member function)